<script lang="ts" setup>
import type { PageSection } from "@/server/models/dynamic-page/index";

import { enumPageSectionKey, enumPageSectionTemplate } from "@/definitions/enum";
import { Misses_Section } from "./index";

const _props = defineProps<{
  settings?: any;
  content?: any;
  section: PageSection;
}>();

const definedDynamicSection: Record<string, any> = {
  [enumPageSectionTemplate[enumPageSectionKey.SECTION]['MISSES']]: Misses_Section,
};

const getCurrentSection = computed(() => _props.settings.template);

const GET_PROPS = computed(() => {
  return () => {
    let props: any = {};
    if (_props.settings) {
      for (const [key, value] of Object.entries(_props.settings)) {
        props = {
          ...props,
          [key]: value,
        };
      }
    }
    return props;
  };
});
</script>

<template>
  <component 
    :is="definedDynamicSection[getCurrentSection]" 
    v-bind="{ ...GET_PROPS(), section: _props.section, content: _props.content, settings: _props.settings }"
  >
    <slot />
  </component>
</template>
